Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv30_routines.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv30_routines.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv30_routines.F90	(revision 4727)
@@ -2647,7 +2647,7 @@
      &          )
 #ifdef ISO
-    use infotrac_phy, ONLY: ntraciso=>ntiso
+    use infotrac_phy, ONLY: ntraciso=>ntiso, niso
     use isotopes_mod, ONLY: essai_convergence, iso_eau,iso_HDO,ridicule
-    use isotopes_routines_mod, ONLY: appel_stewart_vectall
+    use isotopes_routines_mod, ONLY: appel_stewart_vectall,appel_stewart_debug
 #ifdef ISOVERIF
     use isotopes_verif_mod, ONLY: errmax,errmaxrel, &
@@ -3208,4 +3208,6 @@
        enddo
 #endif
+
+        if (1.eq.0) then
         ! appel de appel_stewart_vectorise
         call appel_stewart_vectall(lwork,ncum, &
@@ -3218,4 +3220,13 @@
      &          i,inb, & ! altitude: car cas particulier en INB 
      &          na,nd,nloc,cvflag_grav,ginv,1e-16)
+
+        else !if (1.eq.0) then
+          ! truc simple sans fractionnement
+          ! juste pour debuggage
+          call appel_stewart_debug(lwork,nloc,inb,na,i, &
+                evap,water,rpprec,rr,wdtrain, &
+                xtevap,xtwater,xtp,xt,xtwdtrain)
+        endif ! if (1.eq.0) then
+
 
 #ifdef ISOVERIF
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv3_routines.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv3_routines.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv3_routines.F90	(revision 4727)
@@ -4720,9 +4720,9 @@
                      tv, tvp, wghti, &
                      iflag, precip, Vprecip, Vprecipi, &     ! jyg: Vprecipi
-                     ft, fr, fu, fv, ftra, &                 ! jyg
+                     ft, fr, fr_comp, fu, fv, ftra, &                 ! jyg
                      cbmf, upwd, dnwd, dnwd0, ma, mip, &
 !!                     tls, tps,                             ! useless . jyg
                      qcondc, wd, &
-                     ftd, fqd, qta, qtc, sigt, tau_cld_cv, coefw_cld_cv &
+                     ftd, fqd, qta, qtc, sigt, detrain, tau_cld_cv, coefw_cld_cv &
 #ifdef ISO
      &                    ,xt,xt_wake,xtclw,xtp,xtwater,xtice,xtevap &
@@ -4816,5 +4816,5 @@
 !outputs:
       REAL, DIMENSION (nloc), INTENT (OUT)               :: precip
-      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: ft, fr, fu, fv
+      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: ft, fr, fu, fv , fr_comp
       REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: ftd, fqd
       REAL, DIMENSION (nloc, nd, ntra), INTENT (OUT)     :: ftra
@@ -4826,4 +4826,5 @@
       REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: qcondc                      ! cld
       REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: qtc, sigt                   ! cld
+      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: detrain                     ! Louis : pour le calcul de Klein du terme de variance qui détraine dans lenvironnement
       REAL, DIMENSION (nloc), INTENT (OUT)               :: wd                          ! gust
       REAL, DIMENSION (nloc), INTENT (OUT)               :: cbmf
@@ -4852,4 +4853,5 @@
       REAL, DIMENSION (nloc)                             :: esum, fsum, gsum, hsum
       REAL, DIMENSION (nloc, nd)                         :: th_wake
+      REAL, DIMENSION (nloc, nd, nd)                     :: qdet
       REAL, DIMENSION (nloc)                             :: alpha_qpos, alpha_qpos1
       REAL, DIMENSION (nloc, nd)                         :: qcond, nqcond, wa           ! cld
@@ -4940,4 +4942,5 @@
       ft(il, i) = 0.0
       fr(il, i) = 0.0
+      fr_comp(il,i) = 0.0
       fu(il, i) = 0.0
       fv(il, i) = 0.0
@@ -4950,4 +4953,6 @@
       sigment(il, i) = 0.0 ! cld
       sigt(il, i) = 0.0 ! cld
+      qdet(il,i,:) = 0.0 ! cld
+      detrain(il, i) = 0.0 ! cld
       nqcond(il, i) = 0.0 ! cld
 #ifdef ISO
@@ -5358,4 +5363,5 @@
       IF (j<=inb(il) .AND. iflag(il)<=1) THEN
         fr(il, 1) = fr(il, 1) + 0.01*grav*work(il)*ment(il, j, 1)*(qent(il,j,1)-rr(il,1))
+        fr_comp(il,1) = fr_comp(il,1) + 0.01*grav*work(il)*ment(il, j, 1)*(qent(il,j,1)-rr(il,1))
 
 #ifdef ISO
@@ -5627,4 +5633,5 @@
       IF (i<=inb(il) .AND. iflag(il)<=1) num1 = num1 + 1
     END DO
+        qdet(il,i,i) = qent(il,i,i)                                            ! cld Louis : specific humidity in detraining water
     IF (num1<=0) GO TO 500
 
@@ -6243,4 +6250,5 @@
           fr(il, i) = fr(il, i) + 0.01*grav*dpinv*ment(il, k, i) * &
                                                        (qent(il,k,i)-awat(il)-rr(il,i))
+          fr_comp(il,i) = fr_comp(il,i) + 0.01*grav*dpinv*ment(il, k, i)*(qent(il,k,i)-awat(il)-rr(il,i))
 
 #ifdef ISO
@@ -6313,4 +6321,5 @@
 ! (saturated updrafts resulting from mixing)                                   ! cld
           qcond(il, i) = qcond(il, i) + (elij(il,k,i)-awat(il))                ! cld
+          qdet(il,k,i) = (qent(il,k,i)-awat(il))                               ! cld Louis : specific humidity in detraining water
           qtment(il, i) = qtment(il, i) + qent(il,k,i)                         ! cld
           nqcond(il, i) = nqcond(il, i) + 1.                                   ! cld
@@ -6460,4 +6469,5 @@
 ! (saturated downdrafts resulting from mixing)                                 ! cld
           qcond(il, i) = qcond(il, i) + elij(il, k, i)                         ! cld
+          qdet(il,k,i) = qent(il,k,i)                                          ! cld Louis : specific humidity in detraining water
           qtment(il, i) = qent(il,k,i) + qtment(il,i)                          ! cld
           nqcond(il, i) = nqcond(il, i) + 1.                                   ! cld
@@ -7255,4 +7265,5 @@
         IF  (k<=inb(il) .AND. i<=inb(il) .AND. iflag(il)<=1) THEN   ! cld
           sument(il) =sument(il) + abs(ment(il,k,i))
+          detrain(il,i) = detrain(il,i) + abs(ment(il,k,i))*(qdet(il,k,i) - rr(il,i))*(qdet(il,k,i) - rr(il,i)) ! Louis terme de détrainement dans le bilan de variance
         ENDIF
       ENDDO     ! il
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv3a_uncompress.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv3a_uncompress.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv3a_uncompress.F90	(revision 4727)
@@ -2,5 +2,5 @@
                            iflag, kbas, ktop, &
                            precip, cbmf, plcl, plfc, wbeff, sig, w0, ptop2, &
-                           ft, fq, fu, fv, ftra,  &
+                           ft, fq, fqcomp, fu, fv, ftra,  &
                            sigd, ma, mip, vprecip, vprecipi, upwd, dnwd, dnwd0, &
                            qcondc, wd, cape, cin, &
@@ -12,9 +12,9 @@
                            qta, clw, elij, evap, ep, epmlmMm, eplaMm, &         ! RomP+jyg
                            wdtrainA, wdtrainS, wdtrainM, &                      ! RomP
-                           qtc, sigt,          &
+                           qtc, sigt, detrain,         &
                            epmax_diag, & ! epmax_cape
                            iflag1, kbas1, ktop1, &
                            precip1, cbmf1, plcl1, plfc1, wbeff1, sig1, w01, ptop21, &
-                           ft1, fq1, fu1, fv1, ftra1, &
+                           ft1, fq1, fqcomp1, fu1, fv1, ftra1, &
                            sigd1, ma1, mip1, vprecip1, vprecipi1, upwd1, dnwd1, dnwd01, &
                            qcondc1, wd1, cape1, cin1, &
@@ -26,5 +26,5 @@
                            qta1, clw1, elij1, evap1, ep1, epmlmMm1, eplaMm1, &  ! RomP+jyg
                            wdtrainA1, wdtrainS1, wdtrainM1, &                   ! RomP
-                           qtc1, sigt1, &
+                           qtc1, sigt1, detrain1, &
                            epmax_diag1  & ! epmax_cape
 #ifdef ISO
@@ -72,5 +72,5 @@
   REAL, DIMENSION (nloc), INTENT (IN)                :: ptop2
   REAL, DIMENSION (nloc), INTENT (IN)                :: epmax_diag
-  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: ft, fq, fu, fv
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: ft, fq, fqcomp, fu, fv
   REAL, DIMENSION (nloc, nd, ntra), INTENT (IN)      :: ftra
   REAL, DIMENSION (nloc), INTENT (IN)                :: sigd
@@ -99,5 +99,5 @@
   REAL, DIMENSION (nloc, nd, nd), INTENT (IN)        :: epmlmMm                !RomP+jyg
   REAL, DIMENSION (nloc, nd), INTENT (IN)            :: eplamM                 !RomP+jyg
-  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: qtc, sigt              !RomP
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: qtc, sigt, detrain              !RomP
   REAL, DIMENSION (nloc, nd), INTENT (IN)            :: wdtrainA, wdtrainS, wdtrainM     !RomP
 
@@ -120,5 +120,5 @@
   REAL, DIMENSION (len), INTENT (OUT)                :: epmax_diag1 ! epmax_cape
   REAL, DIMENSION (len), INTENT (OUT)                :: ptop21
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ft1, fq1, fu1, fv1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ft1, fq1, fqcomp1, fu1, fv1
   REAL, DIMENSION (len, nd, ntra), INTENT (OUT)      :: ftra1
   REAL, DIMENSION (len), INTENT (OUT)                :: sigd1
@@ -147,5 +147,5 @@
   REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: epmlmMm1               !RomP+jyg
   REAL, DIMENSION (len, nd), INTENT (OUT)            :: eplamM1                !RomP+jyg
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: qtc1, sigt1            !RomP
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: qtc1, sigt1, detrain1            !RomP
   REAL, DIMENSION (len, nd), INTENT (OUT)            :: wdtrainA1, wdtrainS1, wdtrainM1   !RomP
 
@@ -244,4 +244,5 @@
         ft1(idcum(i), k) = ft(i, k)
         fq1(idcum(i), k) = fq(i, k)
+        fqcomp1(idcum(i), k) = fqcomp(i, k)
         fu1(idcum(i), k) = fu(i, k)
         fv1(idcum(i), k) = fv(i, k)
@@ -273,4 +274,5 @@
         qtc1(idcum(i), k) = qtc(i, k)
         sigt1(idcum(i), k) = sigt(i, k)
+        detrain1(idcum(i), k) = detrain(i, k)
    
 #ifdef ISO
@@ -418,4 +420,5 @@
       ft1(:, 1:nl) = ft(:, 1:nl)
       fq1(:, 1:nl) = fq(:, 1:nl)
+      fqcomp1(:, 1:nl) = fqcomp(:, 1:nl)
       fu1(:, 1:nl) = fu(:, 1:nl)
       fv1(:, 1:nl) = fv(:, 1:nl)
@@ -447,4 +450,5 @@
       qtc1(:, 1:nl) = qtc(:, 1:nl)
       sigt1(:, 1:nl) = sigt(:, 1:nl)
+      detrain1(:, 1:nl) = detrain(:, 1:nl)
 !
       ma1(:, nlp) = 0.
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv3p_mixing.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv3p_mixing.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv3p_mixing.F90	(revision 4727)
@@ -451,5 +451,5 @@
           call iso_verif_aberrant_choix( &
                  xtelij(iso_HDO,il,i,j),elij(il,i,j), &
-                 ridicule,deltalim,'cv3p_mixing 1993')
+                 ridicule,deltalim_snow,'cv3p_mixing 1993')
         endif !if (iso_hdo.gt.0) then
 #ifdef ISOTRAC  
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv_driver.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv_driver.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cv_driver.F90	(revision 4727)
@@ -997,5 +997,5 @@
 
 #ifdef ISO
-       write(*,*) 'klev=',klev
+!       write(*,*) 'klev=',klev
 #ifdef ISOVERIF
        write(*,*) 'cv_driver 930: apres cv3_unsat'
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cva_driver.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cva_driver.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/cva_driver.F90	(revision 4727)
@@ -11,5 +11,5 @@
                       Ale1, Alp1, omega1, &
                       sig1feed1, sig2feed1, wght1, &
-                      iflag1, ft1, fq1, fu1, fv1, ftra1, &
+                      iflag1, ft1, fq1, fqcomp1, fu1, fv1, ftra1, &
                       precip1, kbas1, ktop1, &
                       cbmf1, plcl1, plfc1, wbeff1, &
@@ -26,5 +26,5 @@
                       da1, phi1, mp1, phi21, d1a1, dam1, sigij1, wghti1, & ! RomP, RL
                       qta1, clw1, elij1, evap1, ep1, epmlmMm1, eplaMm1, &  ! RomP, RL
-                      wdtrainA1, wdtrainS1, wdtrainM1, qtc1, sigt1, tau_cld_cv, &     !!jygprl
+                      wdtrainA1, wdtrainS1, wdtrainM1, qtc1, sigt1, detrain1, tau_cld_cv, &     !!jygprl
                       coefw_cld_cv, &                                      ! RomP, AJ
                       epmax_diag1 &  ! epmax_cape
@@ -88,4 +88,5 @@
 ! ntra          Integer        Input        number of tracors
 ! nloc          Integer        Input        dimension of arrays for compressed fields
+! fqcomp1       Real           Output       spec hum tend (only mixed draughts)
 ! k_upper       Integer        Input        upmost level for vertical loops
 ! iflag_con     Integer        Input        version of convect (3/4)
@@ -135,4 +136,5 @@
 ! upwd1         Real           Output       total upward mass flux (adiab+mixed)
 ! dnwd1         Real           Output       saturated downward mass flux (mixed)
+! detrain1      Real           Output     detrainment terme klein
 ! dnwd01        Real           Output       unsaturated downward mass flux
 ! qcondc1       Real           Output       in-cld mixing ratio of condensed water
@@ -209,4 +211,5 @@
   LOGICAL, INTENT (IN)                               :: ok_conserv_q
   REAL, INTENT (IN)                                  :: tau_cld_cv
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: fqcomp1
   REAL, INTENT (IN)                                  :: coefw_cld_cv
   REAL, INTENT (IN)                                  :: delt
@@ -248,4 +251,5 @@
   REAL, DIMENSION (len), INTENT (OUT)                :: cbmf1
   REAL, DIMENSION (len), INTENT (OUT)                :: plcl1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: detrain1   ! detrainement term of mixed draughts in environment
   REAL, DIMENSION (len), INTENT (OUT)                :: plfc1
   REAL, DIMENSION (len), INTENT (OUT)                :: wbeff1
@@ -572,5 +576,5 @@
   REAL, DIMENSION(len,nd)     :: ice, fondue, b
   REAL, DIMENSION(len,nd)     :: frac_a, frac_s, faci               !!jygprl
-  REAL ft(nloc, nd), fq(nloc, nd)
+  REAL ft(nloc, nd), fq(nloc, nd), fqcomp(nloc, nd)
   REAL ftd(nloc, nd), fqd(nloc, nd)
   REAL fu(nloc, nd), fv(nloc, nd)
@@ -598,4 +602,5 @@
   REAL qtc(nloc, nd)         ! cld
   REAL sigt(nloc, nd)        ! cld
+  REAL detrain(nloc, nd)     ! cld
  
 ! RomP >>>
@@ -706,4 +711,5 @@
   ft1(:, :) = 0.0
   fq1(:, :) = 0.0
+  fqcomp1(:, :) = 0.0
   fu1(:, :) = 0.0
   fv1(:, :) = 0.0
@@ -766,4 +772,5 @@
 ! RomP >>>
   sigt1(:, :) = 0.
+  detrain1(:, :) = 0.
   qtc1(:, :) = 0.
   wdtrainA1(:, :) = 0.
@@ -1561,4 +1568,5 @@
         if (prt_level >= 9) &
              PRINT *, 'cva_driver -> cv3_yield'
+
       CALL cv3_yield(nloc, ncum, nd, nd, ntra, ok_conserv_q, &                      ! na->nd
                      icb, inb, delt, &
@@ -1570,10 +1578,10 @@
                      nent, elij, traent, sig, &
                      tv, tvp, wghti, &
-                     iflag, precip, Vprecip, Vprecipi, ft, fq, fu, fv, ftra, &      ! jyg
+                     iflag, precip, Vprecip, Vprecipi, ft, fq, fqcomp, fu, fv, ftra, &      ! jyg
                      cbmf, upwd, dnwd, dnwd0, ma, mip, &
 !!                     tls, tps, &                            ! useless . jyg
                      qcondc, wd, &
 !!                     ftd, fqd, qnk, qtc, sigt, tau_cld_cv, coefw_cld_cv)
-                     ftd, fqd, qta, qtc, sigt, tau_cld_cv, coefw_cld_cv &  !!jygprl
+                     ftd, fqd, qta, qtc, sigt,detrain,tau_cld_cv, coefw_cld_cv &  !!jygprl
 #ifdef ISO
      &                     ,xt,xt_wake,xtclw,xtp,xtwater,xtice,xtevap &
@@ -1673,5 +1681,5 @@
                            iflag, icb, inb, &
                            precip, cbmf, plcl, plfc, wbeff, sig, w0, ptop2, &
-                           ft, fq, fu, fv, ftra, &
+                           ft, fq, fqcomp, fu, fv, ftra, &
                            sigd, ma, mip, vprecip, vprecipi, upwd, dnwd, dnwd0, &
                            qcondc, wd, cape, cin, &
@@ -1683,8 +1691,8 @@
                            qta, clw, elij, evap, ep, epmlmMm, eplaMm, &  ! RomP
                            wdtrainA, wdtrainS, wdtrainM, &                         ! RomP
-                           qtc, sigt, epmax_diag, & ! epmax_cape
+                           qtc, sigt, detrain, epmax_diag, & ! epmax_cape
                            iflag1, kbas1, ktop1, &
                            precip1, cbmf1, plcl1, plfc1, wbeff1, sig1, w01, ptop21, &
-                           ft1, fq1, fu1, fv1, ftra1, &
+                           ft1, fq1, fqcomp1, fu1, fv1, ftra1, &
                            sigd1, ma1, mip1, vprecip1, vprecipi1, upwd1, dnwd1, dnwd01, &
                            qcondc1, wd1, cape1, cin1, &
@@ -1696,5 +1704,5 @@
                            qta1, clw1, elij1, evap1, ep1, epmlmMm1, eplaMm1, & ! RomP
                            wdtrainA1, wdtrainS1, wdtrainM1,                  & ! RomP
-                           qtc1, sigt1, epmax_diag1 & ! epmax_cape
+                           qtc1, sigt1,detrain1,epmax_diag1 & ! epmax_cape
 #ifdef ISO
      &          ,xtprecip,fxt,fxtd, xtVprecip,xtVprecipi, xtclw,xtevap,xtwdtraina       &
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/ecumev6_flux.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/ecumev6_flux.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/ecumev6_flux.F90	(revision 4727)
@@ -0,0 +1,1 @@
+link ../phylmd/ecumev6_flux.F90
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/ini_csts.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/ini_csts.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/ini_csts.F90	(revision 4727)
@@ -0,0 +1,1 @@
+link ../phylmd/ini_csts.F90
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/isotopes_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/isotopes_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/isotopes_mod.F90	(revision 4727)
@@ -302,5 +302,10 @@
    IF(getKey('Rdefault',Rdefault,isoName)) CALL abort_physic(modname, 'can''t get Rdefault',1)
    IF(getKey('Rmethox', Rmethox, isoName)) CALL abort_physic(modname, 'can''t get Rmethox', 1)
-   IF(.NOT.Rdefault_smow) Rdefault(:) = 0.0
+
+   IF(.NOT.Rdefault_smow) then
+        Rdefault(:) = 0.0
+        if (iso_eau.gt.0) Rdefault(iso_eau) = 1.0 ! correction Camille 30 mars 2023
+   ENDIF
+   write(*,*) 'Rdefault=',Rdefault
 
    !--- Sensitivity test: no kinetic effect in sfc evaporation
